<?php

/**
 * usuario_punto_ventaTR actions.
 *
 * @package    cartera
 * @subpackage usuario_punto_ventaTR
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class usuario_punto_ventaTRActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_USUARIO_PUNTO',
        'CA_PUNTO_VENTA',
        'USUARIO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CA_PUNTO_VENTA' =>
        array(
            'id_punto_venta' => 'CA_USUARIO_PUNTO'
        ),
        'USUARIO' =>
        array(
            'username' => 'CA_USUARIO_PUNTO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_USUARIO_PUNTO' =>
        array(
            'username' => 'username',
            'id_punto_venta' => 'id_punto_venta',
            'estado' => 'estado'
        ),
        'CA_PUNTO_VENTA' =>
        array(
            'nombre' => 'nombre_pv',
            'descripcion' => 'descripcion_pv',
            'estado' => 'estado_pv',
            'abreviatura' => 'abreviatura',
            'es_pos' => 'es_pos',
            'enviar_email' => 'enviar_email',
            'id_tipo_factura' => 'id_tipo_factura',
            'aplica_bloqueo' => 'aplica_bloqueo'
        ),
        'USUARIO' =>
        array(
            'username' => 'usernametr',
            'num_doc' => 'num_doc',
            'nombre' => 'nombre',
            'apellido' => 'apellido',
            'num_doc,||, - ,||,nombre,||, ,||,apellido' => 'completo'
        )
    ); //por cada tabla especificar los campos del select
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CA_USUARIO_PUNTO' =>
        array(
            'id_punto_venta,a' => array('!=' => array(-1)),
            'id_punto_venta,b' => array('=' => array('id_punto_venta')),
            'username' => array('=' => array('usernametr')),
//            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
//        ),
//        'CA_PUNTO_VENTA' =>
//        array(
//            'estado' => array('=' => array('estado')),
//            'es_pos' => array('=' => array('es_pos'))
        ),
        'USUARIO' =>
        array(
            'num_doc' => array('=' => array('num_doc'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'USUARIO' =>
        array(
            'nombre' => array('LIKEALLPLUS' => array('nombre', '%')),
            'apellido' => array('LIKEALLPLUS' => array('nombre', '%'))
        )
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'abreviatura', 'num_doc'
    ); //campos para el ordenamiento de la consulta
//    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas
//    protected $table_field_obligatory = array('username'); //campos obligatorios de filtro - estan en el request

    /*
     * Variable manejo de log
     */
    //si es servicio para filtro agregar campo
    protected $filtro = 'usuaio_punto_venta';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'username'; //identificador de la tabla
    protected $id_names = array('username', 'id_punto_venta'); //llave primaria
    protected $field_names = array('estado'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_USUARIO_PUNTO'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'username'; //identificador unico de la tabla

    /**
     * Metodo para remover relacion usuario punto de venta
     *
     * @param sfWebRequest $request
     */

    public function executeRemove(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");


        /*
         * Manejo de errores
         */
        try {

            //variables obligatorias
            $username = $request['usernametr'];
            $id_punto_venta = $request['id_punto_venta'];
            $estado = $request['estado'];

            /*
             * remover usuario punto venta
             */
            //sentencia sql
            $sql = <<<EOD
delete from CA_USUARIO_PUNTO
    where id_punto_venta = $id_punto_venta and  username = '$username'
EOD;
//            $this->logMessage("---" . $sql);
            //ejecuta el sql
            CN_TABLE::executeSQL($sql);



            //el registro removido
            $resultado[] = array(
                'id_punto_venta' => $id_punto_venta,
                'estado' => $estado,
                'username' => $username
            );

            $this->list_data = $resultado;
            $this->logMessage("Se removio el registro.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
